apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: ssh
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: backups-{{ cyrus_name }}
    backups.opsperator.io/service: backups-{{ cyrus_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ cyrus_name }}
  name: {{ cyrus_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ cyrus_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ cyrus_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ cyrus_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ cyrus_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ cyrus_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ cyrus_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - args:
        - /start-cyrus.sh
        env:
        - name: CYRUS_ADMIN
          value: cyrus
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='cyrus'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='cyrus'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - sh
            - -c
            - |
                if test -e /run/cyrus-master.pid; then
                    haspid=$(cat /run/cyrus-master.pid);
                    if test -e /proc/$haspid/cmdline; then
                        exit 0;
                    fi;
                fi;
                exit 1;
          failureThreshold: 10
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 2
        name: cyrus
        ports:
        - containerPort: 24
{% if cyrus_do_pop %}
        - containerPort: 110
{% endif %}
        - containerPort: 143
        - containerPort: 993
{% if cyrus_do_pop %}
        - containerPort: 995
{% endif %}
        - containerPort: 4190
        resources:
          limits:
            cpu: {{ cyrus_cpu_limit }}
            memory: {{ cyrus_memory_limit }}
          requests:
            cpu: {{ cyrus_cpu_request }}
            memory: {{ cyrus_memory_request }}
        securityContext:
          privileged: true
        volumeMounts:
        - mountPath: /certs
          name: pkiconf
        - mountPath: /etc/cyrus.conf.d/cyrus.conf
          name: config
          subPath: cyrus.conf
        - mountPath: /etc/imapd.conf.d/imapd.conf
          name: authconfig
          subPath: imapd.conf
        - mountPath: /etc/openldap
          name: ldapconf
        - mountPath: /etc/pki/cyrus-imapd
          name: data
          subPath: pki
        - mountPath: /etc/saslauthd.conf.d/saslauthd.conf
          name: authconfig
          subPath: saslauthd.conf
        - mountPath: /run/rsyslog
          name: tmp
          subPath: rsyslog
        - mountPath: /run/saslauthd
          name: tmp
          subPath: saslauthd
        - mountPath: /var/lib/cyrus
          name: data
          subPath: lib
        - mountPath: /var/lib/imap
          name: data
          subPath: lib
        - mountPath: /var/spool/cyrus
          name: data
          subPath: spool
        - mountPath: /var/spool/imap
          name: data
          subPath: spool
      - args:
        - /start-syslog.sh
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='cyrus'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='cyrus'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - sh
            - -c
            - |
                test -e /run/rsyslog/dev/log || exit 1
          failureThreshold: 10
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 2
        name: syslog
        resources:
          limits:
            cpu: {{ rsyslog_cpu_limit }}
            memory: {{ rsyslog_memory_limit }}
          requests:
            cpu: {{ rsyslog_cpu_request }}
            memory: {{ rsyslog_memory_request }}
        securityContext:
          privileged: true
        volumeMounts:
        - mountPath: /etc/cyrus.conf
          name: config
          subPath: dummy.conf
        - mountPath: /etc/imapd.conf
          name: config
          subPath: dummy.conf
        - mountPath: /etc/saslauthd.conf
          name: config
          subPath: dummy.conf
        - mountPath: /run/rsyslog
          name: tmp
          subPath: rsyslog
      - args:
        - /start-saslauthd.sh
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='cyrus'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='cyrus'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - sh
            - -c
            - |
                test -e /run/saslauthd/mux || exit 1
          failureThreshold: 10
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 2
        name: saslauthd
        resources:
          limits:
            cpu: {{ saslauthd_cpu_limit }}
            memory: {{ saslauthd_memory_limit }}
          requests:
            cpu: {{ saslauthd_cpu_request }}
            memory: {{ saslauthd_memory_request }}
        securityContext:
          privileged: true
        volumeMounts:
        - mountPath: /certs
          name: pkiconf
        - mountPath: /etc/cyrus.conf
          name: config
          subPath: dummy.conf
        - mountPath: /etc/imapd.conf
          name: config
          subPath: dummy.conf
        - mountPath: /etc/openldap
          name: ldapconf
        - mountPath: /etc/saslauthd.conf.d/saslauthd.conf
          name: authconfig
          subPath: saslauthd.conf
        - mountPath: /run/rsyslog
          name: tmp
          subPath: rsyslog
        - mountPath: /run/saslauthd
          name: tmp
          subPath: saslauthd
      - args:
        - /run-job.sh
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: CYRUS_ADMIN
          value: cyrus
        - name: CYRUS_DEFAULT_QUOTA
          value: "{{ cyrus_default_mailbox_quota }}"
        - name: CYRUS_PASSWORD
          valueFrom:
            secretKeyRef:
              key: cyrus-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=cyrus,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: cyrus-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='cyrus'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='cyrus'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: job
        resources:
          limits:
            cpu: {{ cyrus_job_cpu_limit }}
            memory: {{ cyrus_job_memory_limit }}
          requests:
            cpu: {{ cyrus_job_cpu_request }}
            memory: {{ cyrus_job_memory_request }}
        securityContext:
          privileged: true
        volumeMounts:
        - mountPath: /certs
          name: pkiconf
        - mountPath: /default.sieve
          name: config
          subPath: default.sieve
        - mountPath: /etc/cyrus.conf
          name: config
          subPath: dummy.conf
        - mountPath: /etc/imapd.conf
          name: config
          subPath: dummy.conf
        - mountPath: /etc/openldap
          name: ldapconf
        - mountPath: /etc/saslauthd.conf
          name: authconfig
          subPath: dummy.conf
        - mountPath: /tmp
          name: tmp
          subPath: jobtemp
        - mountPath: /var/spool/imap
          name: data
          subPath: spool
{% if do_backups %}
      - env:
        - name: SSH_USERNAME
          value: root
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        securityContext:
          privileged: true
          runAsUser: 0
        volumeMounts:
        - mountPath: /home/backup
          name: tmp
          subPath: bkphome
        - mountPath: /var/backup
          name: tmp
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if (k8s_flavor == 'kubernetes' and do_podsecuritypolicy) or k8s_flavor == 'openshift' %}
      serviceAccountName: {{ cyrus_name }}
{% else %}
      serviceAccountName: default
{% endif %}
      terminationGracePeriodSeconds: {{ cyrus_termination_timeout | default(60) }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ cyrus_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: authconfig
        secret:
          secretName: {{ cyrus_name }}
      - name: data
        persistentVolumeClaim:
          claimName: {{ cyrus_name }}
      - configMap:
          name: {{ cyrus_name }}
        name: config
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
      - name: pkiconf
        projected:
          sources:
{% if k8s_flavor == 'kubernetes' %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% if smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
          - secret:
              items:
              - key: tls.crt
                path: tls.crt
              name: {{ cyrus_name }}-tls
          - secret:
              items:
              - key: tls.key
                path: tls.key
              name: {{ cyrus_name }}-tls
{% if do_backups %}
      - name: ssh
        secret:
          secretName: backups-{{ cyrus_name }}
{% endif %}
      - emptyDir: {}
        name: tmp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='cyrus'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - cyrus
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='cyrus'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - syslog
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='cyrus'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - saslauthd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='cyrus'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - job
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='cyrus'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_backups and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
    type: ImageChange
{% endif %}
  - type: ConfigChange
{% endif %}
